/**
 * 
 */
package at.hl.wsclient.okb;

import static org.junit.Assert.*;



import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import at.hl.wsclient.okb.OKBService;
import at.hl.wsclient.okb.IOKBService;

/**
 * @author HolperM
 *
 */
public class OKBClientTest {
	
	OKBService srv = null;
	IOKBService port = null;  

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		this.srv = new OKBService();
		this.port = srv.getWSHttpBindingIOKBService1();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void AddAlgorithmTest() {
        ObjectFactory fac = new ObjectFactory();
        AddAlgorithm addA = fac.createAddAlgorithm();
        addA.setDto(fac.createAddAlgorithmDto(fac.createAlgorithm()));
        
        Algorithm a = fac.createAlgorithm();
        a.setAlgorithmClassId(1L);
        a.setDescription(fac.createNamedOKBItemDescription("a new Algo"));
        a.setId(1L);
        a.setName(fac.createNamedOKBItemName("Algorithm Name"));
        a.setPlatformId(1L);
        
		port.addAlgorithm(a);
        Long retval = port.addAlgorithm(a);
        assertTrue("Algortihm wasn't added", retval>0);
	}
	
	@Test
	public void GetAlgorithms() {
		ArrayOfAlgorithm algos = port.getAlgorithms();
		
		for (Algorithm algo:algos.getAlgorithm()) {
			System.out.println("algo ClassId:="+algo.getAlgorithmClassId());
			System.out.println("algo Id:="+algo.getId());
			System.out.println("algo PlattformId:="+algo.getPlatformId());
			System.out.println("algo Class:="+algo.getClass());
			System.out.println("algo Description:="+algo.getDescription().getValue());
			System.out.println("algo Name:="+algo.getName().getValue());
		}
		assertTrue("No Algorithms found!", algos.getAlgorithm().size()>0);
	}	
	
}
